%{
	#include <stdio.h>
	#include <stdlib.h>
	#include <sys/types.h>
        #include <sys/stat.h> 
        #include <errno.h> 
	#include "inst-bf.h"
	#include "bf.yacc.h"

	#define BRAINFUCK 	0
	#define OOK		1
	#define SPOON 		2
	#define FUCK		3
	
	FILE *fsortie;
	int code_type;

	/* command line options */

	int errflg = 0; 
	char * carg;
	int cflag = 0;
	char last_inst = 0;


	
%}
%option yylineno

%%
	/******************************************/
010	{if(code_type == SPOON) {yylval=new_inst('>'); return INST;}}
011	{if(code_type == SPOON) {yylval=new_inst('<'); return INST;}}
1	{if(code_type == SPOON) {yylval=new_inst('+'); return INST;}}
000	{if(code_type == SPOON) {yylval=new_inst('-'); return INST;}}
001010	{if(code_type == SPOON) {yylval=new_inst('.'); return INST; }}
0010110	{if(code_type == SPOON) {yylval=new_inst(','); return INST; }}
00100	{if(code_type == SPOON) return BEGLOOP; }
0011	{if(code_type == SPOON) return ENDLOOP; }

	/******************************************/
\>	{if(code_type == BRAINFUCK) {yylval=new_inst(yytext[0]); return INST;}}
\<	{if(code_type == BRAINFUCK) {yylval=new_inst(yytext[0]); return INST;}}
\+	{if(code_type == BRAINFUCK) {yylval=new_inst(yytext[0]); return INST;}}
\-	{if(code_type == BRAINFUCK) {yylval=new_inst(yytext[0]); return INST;}}
\.	{if(code_type == BRAINFUCK) {yylval=new_inst(yytext[0]); return INST; }}
\,	{if(code_type == BRAINFUCK) {yylval=new_inst(yytext[0]); return INST; }}
\[	{if(code_type == BRAINFUCK) return BEGLOOP; }
\]	{if(code_type == BRAINFUCK) return ENDLOOP; }

	/******************************************/
Ook\.\ Ook\?	{if(code_type == OOK) {yylval=new_inst('>'); return INST;}}
Ook\?\ Ook\.	{if(code_type == OOK) {yylval=new_inst('<'); return INST;}}
Ook\.\ Ook\.	{if(code_type == OOK) {yylval=new_inst('+'); return INST;}}
Ook\!\ Ook\!	{if(code_type == OOK) {yylval=new_inst('-'); return INST;}}
Ook\!\ Ook\.	{if(code_type == OOK) {yylval=new_inst('.'); return INST; }}
Ook\.\ Ook\!	{if(code_type == OOK) {yylval=new_inst(','); return INST; }}
Ook\!\ Ook\?	{if(code_type == OOK) return BEGLOOP; }
Ook\?\ Ook\!	{if(code_type == OOK) return ENDLOOP; }

	/******************************************/
[fF]\ ?.\ ?.\ ?[kK]	{if(code_type == FUCK) {last_inst = '>'; yylval=new_inst(last_inst); return INST;}}
[Ss]\ ?.\ ?.\ ?[gG]		{if(code_type == FUCK) {last_inst = '<'; yylval=new_inst(last_inst); return INST;}}
[bB]\ ?.\ ?.\ ?[bB]		{if(code_type == FUCK) {last_inst = '+'; yylval=new_inst(last_inst); return INST;}}
[tT]\ ?.\ ?.\ ?[sS]		{if(code_type == FUCK) {last_inst = '-'; yylval=new_inst(last_inst); return INST;}}
[cC]\ ?.\ ?.\ ?[kK]		{if(code_type == FUCK) {last_inst = '.'; yylval=new_inst(last_inst); return INST; }}
[kK]\ ?.\ ?.\ ?[bB]		{if(code_type == FUCK) {last_inst = ','; yylval=new_inst(last_inst); return INST; }}
[aA]\ ?.\ ?.\ ?[eE]		{if(code_type == FUCK) return BEGLOOP; }
[bB]\ ?.\ ?.\ ?[tT]		{if(code_type == FUCK) return ENDLOOP; }
\!			{if(code_type == FUCK) {
						if(last_inst=='[') return BEGLOOP;
						else if(last_inst == ']') return ENDLOOP;
						else {/*printf("rep(%c)", last_inst);*/yylval=new_inst(last_inst); return INST;}
			}}

.|\n	{  }

%%

yyerror(char *s) { printf("ligne %d : %s pour %s\n", yylineno, s, yytext); }

static void usage(prog) char *prog;{
  fprintf(stderr, "usage: %s [-B, -O, -S, -F] sourcefile [-o outfile]\n", prog);
  exit(1);
}



int main (int argc, char *argv[])
{
	int i;
	int debut = 0;

	unsigned char taille_nulle[] = {0,0,0,0};

	char *fname, *outname;
	int c; 
	extern char * optarg; 
	extern int optind, opterr; 
	char * progname = argv[0];
	struct stat droits;


	outname = "./a.out";

while ((c = getopt(argc , argv, "O:B:S:F:o:")) != -1){
	switch (c) {
		case 'O':
			fname = optarg;
			/*printf("fname=%s\n", fname);*/
			code_type = OOK;
			break;
		case 'B':
			fname = optarg;
			/*printf("fname=%s\n", fname);*/
			code_type = BRAINFUCK;
			break;
		case 'S':
			fname = optarg;
			/*printf("fname=%s\n", fname);*/
			code_type = SPOON;
			break;
		case 'F':
			fname = optarg;
			/*printf("fname=%s\n", fname);*/
			code_type = FUCK;
			break;
		case 'o':
			cflag++;
			outname = optarg;
			/*printf("outname=%s\n", outname);*/
			break;
		case '?':
			errflg++;
			break;
	}
	if (errflg){
		usage(progname);
	}
}

if (argc <= 2 || argc == 4 || argc >= 6){
	fprintf(stderr, "Bad number of arguments\n");
	usage(progname);
}

	

	yyin = fopen(fname, "r");
	/*printf("ouverture de %s en r : %d\n", fname, yyin);*/
	if(yyin){
		fsortie = fopen(outname, "w");
		/*printf("ouverture de %s en w : %d\n", outname, fsortie);*/
		init_code();
		yyparse();
		finalize(fsortie);
		
		if(0==stat(outname, &droits)) {
			chmod(outname, droits.st_mode | S_IXUSR);
		} else {
			fprintf(stderr, "could not chmod : %s\n", strerror(errno));
			
		}
		return EXIT_SUCCESS;
	}


	return EXIT_FAILURE;
		
	
}

int yywrap()
{
	return 1;
}
