#ifndef ENTETE_ELF_H
#define ENTETE_ELF_H

unsigned char header1[] = {
	0x7f, 'E', 'L', 'F', 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x03, 0x00, 0x01, 0x00, 0x00, 0x00,
	0x54, 0xb0, 0xe9, 0x45, 0x34, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x34, 0x00, 0x20, 0x00, 0x01, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	
	0x00, 0xb0, 0xe9, 0x45, /* ne change jamais, c'est l'adresse de base */
	
	0x00, 0xb0, 0xe9, 0x45, /* ne change jamais, c'est l'adresse de base */
};

/* 	header1 est suivi de ce chiffre (taille totale) : 	
	0x76, 0x00, 0x00, 0x00, ajouter le nombre d'instruction à cette base 
 	(0x76 est le nombre d'instructions d'un programme qui ne fait rien)
	C'est la section dans laquelle on va définir la taille totale de l'exécutable
	(phdr.p_filesz)

 	ce chiffre est ensuite suivi de header2 
*/

unsigned char header2[] = {
	/*
	0x8833 = taille du tableau : 5000=0x8813 + 0x2000 de décalage par rapport au début */
	0x88, 0x33, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00,
	
	0xb9, 0x00, 0xd0, 0xe9, 0x45, /* mov ecx, début + 0x2000 */
	0xb8, 0x88, 0x13, 0x00, 0x00, /* mov eax, 0x1388 (taille du tableau) */
	/* boucle : */
	0xc6, 0x01, 0x00, /* mov BYTE [ecx], 0 */
	0x41, /* inc ecx */
	0x48, /* dec eax */
	0x3d, 0x00, 0x00, 0x00, 0x00, /* cmp eax, 0 */
	0x75, 0xf4 /* jne boucle */
};

unsigned char footer[] = {
	0xb8, 0x01, 0x00, 0x00, 0x00, /* mov 	eax, 1 */
	0xbb, 0x00, 0x00, 0x00, 0x00, /* mov 	ebx, 0 (code de reotur) */
	0xcd, 0x80	/* int 0x80 (appel système, exit) */
};

unsigned char plus[] = {	/*  +  */
	0xfe, 0x01	/* dec BYTE [ecx] */
};

unsigned char minus[] = {	/*  -  */
	0xfe, 0x09	/* inc BYTE [ecx] */
};

unsigned char inc[] = {		/*  >  */
	0x41	/* inc ecx */
};

unsigned char dec[] = {		/*  <  */
	0x49	/* dec ecx */
};

unsigned char comma[] = {		/*  ,  */
	0xba, 0x01, 0x00, 0x00, 0x00, /* mov edx, 1 */ 
	0x31, 0xc0, /* xor eax, eax */
	0xb0, 0x03, /* mov al, 3 */
	0x31, 0xdb, /* xor ebx, ebx */
	0x43,       /* inc ebx */
	0xcd, 0x80, /* int 0x80 */
// END-OF-LINE BEHAVIOR : uncommenting next 3 lines put 0 if \n is entered	
// 	0x80, 0x39, 0x0a, /* cmp [ecx], BYTE 10 */
// 	0x75, 0x03, /* je suite (juste après) */
// 	0xc6, 0x01, 0x00, /* mov BYTE [ecx], 0 */
};

unsigned char dot[] = {		/*  .  */
	0xba, 0x01, 0x00, 0x00, 0x00, /* mov edx, 1 */ 
	0xb0, 0x04, /* mov al, 4 */
	0x31, 0xdb, /* xor ebx, ebx */
	0x43,       /* inc ebx */
	0xcd, 0x80,  /* int 0x80 */

};

unsigned char end[] = {		/*  ]  */
	0x80, 0x39, 0x00,	/* cmp [ecx], BYTE 0 */
	0x74, 0x05, /* je suite (juste après) */
//	0x80, 0x39, 0x0a, /* cmp [ecx], BYTE 10 */
//	0x74, 0x05, /* je suite (juste après) */
	0xe9, /* jmp : */
 /* 
	0x??, 0x??, 0x??, 0x?? : l'adresse du début de la boucle 
	suite: label de suite des instructions
*/
 
};


#endif /* ENTETE_ELF_H */
