#include "inst-bf.h"
#include "entete.h"
#include <stdlib.h>

YYSTYPE new_inst(char c)
{
	extern int code_type;
	YYSTYPE ret;
	ret.c = c;
	/*if(c)printf("%c", c);*/
	switch(c) {
		case '+':
			ret.taille = 2; break;
		case '-':
			ret.taille = 2; break;
		case '>':
			ret.taille = 1; break;
		case '<':
			ret.taille = 1; break;
		case ',':
			ret.taille = 14; break;
		case '.':
			ret.taille = 12; break;
		default: 
			ret.taille = 0;
	}
	
	return ret;

}

void init_code()
{
	cur_inst = NULL;
	begin = NULL;
}

code *add_code()
{
	code *new = malloc(sizeof(code));
	new->next = NULL;
	if(begin == NULL) {
		begin = new;
		cur_inst = begin;
	} else {
		cur_inst->next = new;
		cur_inst = new;
	}
}

void put_code(YYSTYPE inst)
{
	code *new = add_code();	
	new->taille = inst.taille;
	switch(inst.c){
		case '+':
			new->bin = plus; break;
		case '-':
			new->bin = minus; break;
		case '>':
			new->bin = inc; break;
		case '<':
			new->bin = dec; break;
		case ',':
			new->bin = comma; break;
		case '.':
			new->bin = dot; break;
		default: 
			new->bin = NULL;
	}

}

void end_loop(int go_back)
{
	code *new = add_code();	
	new->taille = sizeof(end) + 4;
	new->bin = malloc(new->taille);
	memcpy(new->bin, end, sizeof(end));
	go_back = -go_back;
	memcpy(new->bin + sizeof(end), &go_back, sizeof(go_back));

}

void finalize(FILE *fd)
{
	if(begin == NULL){
		printf("begin == NULL\n");
		return;
	}
	
	code *cur_code;
	int total_size = 0;
	for(cur_code = begin;cur_code; cur_code = cur_code->next){
		total_size += cur_code->taille;
	}

	print_out(header1, sizeof(header1), fd);
	print_out(&total_size, sizeof(total_size), fd);
	print_out(header2, sizeof(header2), fd);

	for(cur_code = begin;cur_code; cur_code = cur_code->next){
		print_out(cur_code->bin, cur_code->taille, fd);	
	}
	print_out(footer, sizeof(footer), fd);

	fclose(fd);

}

void print_out(void *bin, int size, FILE *fd)
{
	fwrite(bin, size, 1, fd);	
}


